<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                       ***
  ***      File:  admin_products_edit.php                                  ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                  ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "includes/editgrid.php");
	include_once ($root_folder_path . "includes/tree.php");
	include_once ($root_folder_path . "includes/friendly_functions.php");
	include_once ($root_folder_path . "messages/".$language_code."/cart_messages.php");

	check_admin_security("products_categories");

	$currency = get_currency();
	$html_editor = get_setting_value($settings, "html_editor", 1);

	$operation = get_param("operation");
	$page_show = get_param("page_show");
	$category_id = get_param("category_id");
	$items_ids = get_param("items_ids");
	$total_columns = get_param("total_columns");
	if(!strlen($category_id)) $category_id = "0";
	
	$return_page = get_param("rp");
	if(!strlen($return_page)) $return_page = "admin_items_list.php?category_id=" . urlencode($category_id);
	$errors = "";

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_products_edit.html");

	$t->set_var("admin_products_edit_href", "admin_products_edit.php");
	$t->set_var("admin_items_list_href", "admin_items_list.php");
	$t->set_var("admin_upload_href", "admin_upload.php");
	$t->set_var("admin_select_href", "admin_select.php");
	
	$t->set_var("ADD_TO_CART_MSG", ADD_TO_CART_MSG);
	
	$t->set_var("items_ids", $items_ids);
	$t->set_var("category_id", $category_id);
	$t->set_var("total_columns", $total_columns);

  $t->set_var("date_edit_format", join("", $date_edit_format));
	$t->set_var("html_editor", $html_editor);
	
	$currency_left = $currency["left"];
	$currency_right = $currency["right"];
	$currency_rate = $currency["rate"];
	$t->set_var("currency_left", $currency_left);
	$t->set_var("currency_right", $currency_right);
	$t->set_var("currency_rate", $currency_rate);

	include("./admin_header.php");
	include("./admin_footer.php");
	
  $table_alias = "i";
	
	function set_db_column($column_name, $column_title)
	{
		    global $t, $db, $total_columns, $table_alias, $checked_columns;
    		$total_columns++;
    		$column_checked = in_array($table_alias.".".$column_name, $checked_columns) ? " checked " : "";
		    $t->set_var("col", $total_columns);
		    $t->set_var("column_name", htmlspecialchars($column_name));
		    $t->set_var("column_title", htmlspecialchars($column_title));
		    $t->set_var("column_checked", $column_checked);
		    $t->parse("rows", true);
		    if($total_columns % 2 == 0)
        {
			     $t->parse("columns", true);
			     $t->set_var("rows", "");
		    }

	}
	
		$db_columns = array(
		"is_showing" => "Available For Sales",
		"is_approved" => "Approved",
    "item_order" => "Product Order",
		"item_type_id" => "Product Type",
		"item_name" => "Product Name",
		"friendly_url" => "Friendly URL",
		"manufacturer_id" => "Manufacturer Name",
		"manufacturer_code" =>"Manufacturer Code",
    "weight" => "Weight",
    "issue_date" => "Product Issue Date",
    "is_compared" => "Allow Products Comparison",
		"tax_free" => "Tax Free Product",
		"language_code" => "Language",
		"price" => "Price",
		"buying_price" => "Buying Price",
		"properties_price" => "Options Price",
		"is_sales" => "Activate Discount",
		"sales_price" => "Discount Price",
		"trade_price" => "Trade Price",
		"trade_sales" => "Discount Trade Price",
		"discount_percent" => "Discount Percent",
		"short_description" => "Short Description",
		"features" => "Features",
		"full_desc_type" => "Full Description Type",
		"full_description" => "Full Description",
		"meta_title" => "Page Title",
		"meta_keywords" => "Meta Keywords",
		"meta_description" => "Meta Description",
		"is_special_offer" => "Is Special Offer",
		"special_offer" => "Special Offer",
		"small_image" => "Small Image",
		"small_image_alt" => "Small Image Alt",
		"big_image" => "Big Image",
		"big_image_alt" =>"Big Image Alt",
		"super_image" => "Super-Sized Image",
		"template_name" => "Custom Template",
		"hide_add_list" => "Hide Add to Cart button on Products list Page",
		"hide_add_details" => "Hide Add to Cart button on Product Details Page",
		"use_stock_level" => "Use Stock Level",
		"stock_level" => "Quantity In Stock",
		"hide_out_of_stock" => "Hide Off Limits Products",
		"disable_out_of_stock" => "Disable Off Limits Products",
		"downloadable" => "Is Downloadable",
		"download_period" => "Download Period",
		"download_path" => "Download Path",
		"generate_serial" => "Generate Serial Number",
		"activations_number" => "Max Number of Activations",
		"shipping_in_stock" => "In Stock Availability",
		"shipping_out_stock" => "Out of Stock Availability",
		"shipping_rule_id" => "Shipping Restrictions",
		"votes" => "Total Votes",
		"points" => "Total Points",
		"notes" => "Notes",
		"buy_link" => "Direct Buy Link"
	);
	
	$tree = new VA_Tree("category_id", "category_name", "parent_category_id", $table_prefix . "categories", "tree");
	$tree->show($category_id);
	
  if (strlen($page_show))
  {
      $total_columns = 0;
      $default_columns = "";
      $sql  = " SELECT edited_item_fields FROM " . $table_prefix . "admins WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
		  $default_columns = get_db_value($sql);
	    $checked_columns = explode(",", $default_columns);
     
	   foreach($db_columns as $column_name => $column_info)
	      set_db_column($column_name, $column_info);
	   if($total_columns % 2 != 0)
	      $t->parse("columns", true);
	   $t->set_var("total_columns", $total_columns);
	   $t->parse("fields", false);
     $t->pparse("main");
	   exit;
  }
  else
  {
      if(!strlen($operation))
      {
			   // generate selected columns
			   $columns_selected = 0;
			   $edit_fields  = "";
			   for($col = 1; $col <= $total_columns; $col++) {
				    $column_name = get_param("db_column_" . $col);
				    $column_title = get_param("column_title_" . $col);
				    if($column_name) {
					     $columns_selected++;
					     if($columns_selected > 1) {
						      $edit_fields .= ",";
					     }
					     $edit_fields .= $table_alias . "." . $column_name;
					     $columns[] = $column_name;
				    }
			   }
			   // update default columns list
			   $sql = " UPDATE " . $table_prefix . "admins SET edited_item_fields=" . $db->tosql($edit_fields, TEXT);
			   $sql .= " WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
			   $db->query($sql);
     }
     else
     {
        $sql  = " SELECT edited_item_fields FROM " . $table_prefix . "admins WHERE admin_id=" . $db->tosql(get_session("session_admin_id"), INTEGER);
		    $default_columns = get_db_value($sql);
	      $checked_columns = explode(",", $default_columns);
	      $db_column = array();
        $ii = 1;
	      foreach($db_columns as $column_name => $column_info)
	      {
           if (in_array($table_alias.".".$column_name, $checked_columns))
           {
              $db_column[$ii] = $column_name;
              $ii++;
           }
        }
        $total_columns = $ii - 1;
     }
  }

	$r = new VA_Record($table_prefix . "items", "items");

 for ($i = 1; $i <= $total_columns; $i++)
{
   if (isset($db_column[$i])) {
      $column_name = $db_column[$i];
   }
   else {
      $column_name = get_param("db_column_$i");
   }
   if (strlen($column_name))
   {
      switch ($column_name)
      {
         case "is_showing" :
            $r->add_checkbox("is_showing", INTEGER, "Available For Sales");
            break;
         case "is_approved" :
         	  $approve_values = array(array(1, YES_MSG), array(0, NO_MSG));
	          $r->add_radio("is_approved", INTEGER, $approve_values, "Approved");
            break;
         case "item_order" :
          	$r->add_textbox("item_order", INTEGER, "Product Order");
	          $r->parameters["item_order"][REQUIRED] = true;
            break;
         case "item_type_id" :
	          $item_types = get_db_values("SELECT * FROM " . $table_prefix . "item_types", array(array("", "")));
	          $r->add_select("item_type_id", INTEGER, $item_types, "Product Type");
	          $r->parameters["item_type_id"][REQUIRED] = true;
            break;
         case "item_name" :
            $item_included = true;
	          $r->add_textbox("item_name", TEXT, "Product Name");
	          $r->parameters["item_name"][REQUIRED] = true;
            break;
         case "friendly_url" :
	          $r->add_textbox("friendly_url", TEXT, "Friendly URL");
						$r->change_property("friendly_url", USE_SQL_NULL, false);
 						$r->change_property("friendly_url", BEFORE_VALIDATE, "validate_friendly_url", array("is_grid" => true));
            break;
         case "manufacturer_id" :
	          $manufacturers = get_db_values("SELECT * FROM " . $table_prefix . "manufacturers", array(array("", "None")));
	          $r->add_select("manufacturer_id", INTEGER, $manufacturers, "Manufacturer Name");
            break;
         case "manufacturer_code" :
	          $r->add_textbox("manufacturer_code", TEXT, "Manufacturer Code");
            break;
         case "weight" :
          	$r->add_textbox("weight", NUMBER, "Weight");
            break;
         case "issue_date" :
	          $r->add_textbox("issue_date", DATETIME, "Product Issue Date");
	          $r->change_property("issue_date", VALUE_MASK, $date_edit_format);
            break;
         case "is_compared" :
	          $r->add_checkbox("is_compared", INTEGER, "Allow Products Comparison");
            break;
         case "tax_free" :
	          $r->add_checkbox("tax_free", INTEGER, "Tax Free Product");
            break;
         case "language_code" :
	          $languages = get_db_values("SELECT language_code, language_name FROM " . $table_prefix . "languages", array(array("", "All")));
	          $r->add_select("language_code", TEXT, $languages, "Language");
            break;
         case "price" :
	          $r->add_textbox("price", NUMBER, "Price");
	          $r->parameters["price"][REQUIRED] = true;
            break;
         case "buying_price" :
            $r->add_textbox("buying_price", NUMBER, "Buying Price");
            break;
         case "properties_price" :
           	$r->add_textbox("properties_price", NUMBER, "Options Price");
            break;
         case "is_sales" :
          	$r->add_checkbox("is_sales", INTEGER, "Activate Discount");
         case "sales_price" :
            $r->add_textbox("sales_price", NUMBER, "Discount Price");
            break;
         case "trade_price" :
            $r->add_textbox("trade_price", NUMBER, "Trade Price");
            break;
         case "trade_sales" :
            $r->add_textbox("trade_sales", NUMBER, "Discount Trade Price");
            break;
         case "discount_percent" :
            $r->add_textbox("discount_percent", NUMBER, "Discount Percent");
            break;
         case "short_description" :
            $r->add_textbox("short_description", TEXT, "Short Description");
            break;
         case "features" :
            $r->add_textbox("features", TEXT, "Features");
            break;
         case "full_desc_type" :
         	  $content_types =
		        array
            (
			         array(1, "HTML"), array(0, "Plain Text")
		        );
            $r->add_radio("full_desc_type", INTEGER, $content_types, "Full Description Type");
            break;
         case "full_description" :
            $r->add_textbox("full_description", TEXT, "Full Description");
            break;
         case "meta_title" :
            $r->add_textbox("meta_title", TEXT, "Page Title");
            break;
         case "meta_keywords" :
            $r->add_textbox("meta_keywords", TEXT, "Meta Keywords");
            break;
         case "meta_description" :
            $r->add_textbox("meta_description", TEXT, "Meta Description");
            break;
         case "is_special_offer" :
            $r->add_checkbox("is_special_offer", INTEGER, "Is Special Offer");
            break;
         case "special_offer" :
            $r->add_textbox("special_offer", TEXT, "Special Offer");
            break;
         case "small_image" :
            $r->add_textbox("small_image", TEXT, "Small Image");
            break;
         case "small_image_alt" :
            $r->add_textbox("small_image_alt", TEXT, "Small Image Alt");
            break;
         case "big_image" :
            $r->add_textbox("big_image", TEXT, "Big Image");
            break;
         case "big_image_alt" :
            $r->add_textbox("big_image_alt", TEXT, "Big Image Alt");
            break;
         case "super_image" :
            $r->add_textbox("super_image", TEXT, "Super-Sized Image");
            break;
         case "template_name" :
            $r->add_textbox("template_name", TEXT, "Custom Template");
            break;
         case "hide_add_list" :
            $r->add_checkbox("hide_add_list", INTEGER, "Hide Add to Cart button on Products list Page");
            break;
         case "hide_add_details" :
            $r->add_checkbox("hide_add_details", INTEGER, "Hide Add to Cart button on Product Details Page");
            break;
         case "use_stock_level" :
            $r->add_checkbox("use_stock_level", INTEGER, "Use Stock Level");
            break;
         case "stock_level" :
            $r->add_textbox("stock_level", NUMBER, "Quantity In Stock");
            break;
         case "hide_out_of_stock" :
            $r->add_checkbox("hide_out_of_stock", INTEGER, "Hide Off Limits Products");
            break;
         case "disable_out_of_stock" :
            $r->add_checkbox("disable_out_of_stock", INTEGER, "Disable Off Limits Products");
            break;
         case "downloadable" :
            $r->add_checkbox("downloadable", INTEGER, "Is Downloadable");
            break;
         case "download_period" :
            $r->add_textbox("download_period", INTEGER, "Download Period");
            break;
         case "download_path" :
            $r->add_textbox("download_path", TEXT, "Path to Downloadable File");
            break;
         case "generate_serial" :
            $r->add_checkbox("generate_serial", INTEGER, "Generate Serial Number");
            break;
         case "activations_number" :
            $r->add_textbox("activations_number", INTEGER, "Max Number of Activations");
            break;
         case "shipping_in_stock" :
            $times = get_db_values("SELECT * FROM " . $table_prefix . "shipping_times", array(array("", "None")), 90);
	          $r->add_select("shipping_in_stock", INTEGER, $times, "In Stock Availability");
            break;
         case "shipping_out_stock" :
            $times = get_db_values("SELECT * FROM " . $table_prefix . "shipping_times", array(array("", "None")), 90);
	          $r->add_select("shipping_out_stock", INTEGER, $times, "Out of Stock Availability");
            break;
         case "shipping_rule_id" :
            $rules = get_db_values("SELECT * FROM " . $table_prefix . "shipping_rules", array(array("", "None")), 90);
	          $r->add_select("shipping_rule_id", INTEGER, $rules, "Shipping Restrictions");
            break;
         case "votes" :
            $r->add_textbox("votes", INTEGER, "Total Votes");
            break;
         case "points" :
            $r->add_textbox("points", INTEGER, "Total Points");
            break;
         case "notes" :
            $r->add_textbox("notes", TEXT, "Notes");
            break;
         case "buy_link" :
            $r->add_textbox("buy_link", TEXT, "Direct Buy Link");
            break;
            
      }
      
   }
   
}


    	$r->add_hidden("item_id", INTEGER);
	    $r->change_property("item_id", USE_IN_WHERE, true);
      if (!isset($item_included))
         $r->add_hidden("item_name_hid", TEXT);
	    
	    
	    $number_items = get_param("number_items");
    	$eg = new VA_EditGrid($r, "items");

		  for($i = 1; $i <= $number_items; $i++)
		  {
			   foreach ($eg->record->parameters as $parameter_name => $parameter)
			   {
				    $form_value = get_param($eg->record->parameters[$parameter_name][CONTROL_NAME] . "_" . $i);
    				if($eg->record->parameters[$parameter_name][CONTROL_TYPE] == CHECKBOX && !strlen($form_value)) {
  					   $form_value = 0;
  			    }
      			$eg->values[$i][$parameter_name] = $form_value;
			   }
		  }
    	
if(strlen($operation))
{
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}

		$is_valid = $eg->validate();

		if($is_valid)
		{
		  $number_items = $number_items ? $number_items : get_param("number_" . $eg->block_name);
		  for($i = 1; $i <= $number_items; $i++)
		  {
			  $non_empty = $eg->set_record($i);
			  $is_all_where = $eg->record->check_where();
        if($is_all_where)
        {
				    $eg->record->update_record();
			  }
        else if($non_empty)
        {
				    $eg->record->insert_record();
			  }
		  }
			header("Location: " . $return_page);
			exit;
		}
}
else
{


  		// manually get items
	  	$number_items = 0;
		  $sql  = " SELECT *";
		  $sql .= " FROM " . $table_prefix . "items ";
		  $sql .= " WHERE item_id IN (" . $db->tosql($items_ids, TEXT, false) . ")";

  		$db->query($sql);
	  	while($db->next_record())
		  {
			  $number_items++;
			  $eg->values[$number_items]["item_id"] = $db->f("item_id");
		    $eg->values[$number_items]["is_showing"] = $db->f("is_showing");
		    $eg->values[$number_items]["is_approved"] = $db->f("is_approved");
			  $eg->values[$number_items]["item_order"] = $db->f("item_order");
			  $eg->values[$number_items]["item_type_id"] = $db->f("item_type_id");
			  $eg->values[$number_items]["item_name_hid"] = $db->f("item_name");
			  $eg->values[$number_items]["item_name"] = $db->f("item_name");
			  $eg->values[$number_items]["friendly_url"] = $db->f("friendly_url");
			  $eg->values[$number_items]["manufacturer_id"] = $db->f("manufacturer_id");
			  $eg->values[$number_items]["manufacturer_code"] = $db->f("manufacturer_code");
			  $eg->values[$number_items]["issue_date"] = $db->f("issue_date", DATETIME);
			  $eg->values[$number_items]["weight"] = $db->f("weight");
			  $eg->values[$number_items]["is_compared"] = $db->f("is_compared");
			  $eg->values[$number_items]["tax_free"] = $db->f("tax_free");
			  $eg->values[$number_items]["language_code"] = $db->f("language_code");
			  $eg->values[$number_items]["price"] = $db->f("price");
			  $eg->values[$number_items]["buying_price"] = $db->f("buying_price");
			  $eg->values[$number_items]["properties_price"] = $db->f("properties_price");
			  $eg->values[$number_items]["is_sales"] = $db->f("is_sales");
			  $eg->values[$number_items]["sales_price"] = $db->f("sales_price");
			  $eg->values[$number_items]["trade_price"] = $db->f("trade_price");
			  $eg->values[$number_items]["trade_sales"] = $db->f("trade_sales");
			  $eg->values[$number_items]["discount_percent"] = $db->f("discount_percent");
			  $eg->values[$number_items]["short_description"] = $db->f("short_description");
			  $eg->values[$number_items]["features"] = $db->f("features");
			  $eg->values[$number_items]["full_desc_type"] = $db->f("full_desc_type");
			  $eg->values[$number_items]["full_description"] = $db->f("full_description");
			  $eg->values[$number_items]["meta_title"] = $db->f("meta_title");
			  $eg->values[$number_items]["meta_keywords"] = $db->f("meta_keywords");
			  $eg->values[$number_items]["meta_description"] = $db->f("meta_description");
			  $eg->values[$number_items]["is_special_offer"] = $db->f("is_special_offer");
			  $eg->values[$number_items]["special_offer"] = $db->f("special_offer");
			  $eg->values[$number_items]["small_image"] = $db->f("small_image");
			  $eg->values[$number_items]["small_image_alt"] = $db->f("small_image_alt");
			  $eg->values[$number_items]["big_image"] = $db->f("big_image");
			  $eg->values[$number_items]["big_image_alt"] = $db->f("big_image_alt");
			  $eg->values[$number_items]["super_image"] = $db->f("super_image");
			  $eg->values[$number_items]["template_name"] = $db->f("template_name");
			  $eg->values[$number_items]["hide_add_list"] = $db->f("hide_add_list");
			  $eg->values[$number_items]["hide_add_details"] = $db->f("hide_add_details");
			  $eg->values[$number_items]["use_stock_level"] = $db->f("use_stock_level");
			  $eg->values[$number_items]["stock_level"] = $db->f("stock_level");
			  $eg->values[$number_items]["hide_out_of_stock"] = $db->f("hide_out_of_stock");
			  $eg->values[$number_items]["disable_out_of_stock"] = $db->f("disable_out_of_stock");
			  $eg->values[$number_items]["downloadable"] = $db->f("downloadable");
			  $eg->values[$number_items]["download_period"] = $db->f("download_period");
			  $eg->values[$number_items]["download_path"] = $db->f("download_path");
			  $eg->values[$number_items]["generate_serial"] = $db->f("generate_serial");
			  $eg->values[$number_items]["activations_number"] = $db->f("activations_number");
			  $eg->values[$number_items]["shipping_in_stock"] = $db->f("shipping_in_stock");
			  $eg->values[$number_items]["shipping_out_stock"] = $db->f("shipping_out_stock");
			  $eg->values[$number_items]["shipping_rule_id"] = $db->f("shipping_rule_id");
			  $eg->values[$number_items]["votes"] = $db->f("votes");
			  $eg->values[$number_items]["points"] = $db->f("points");
			  $eg->values[$number_items]["notes"] = $db->f("notes");
			  $eg->values[$number_items]["buy_link"] = $db->f("buy_link");
			}
			
}

  
	$t->set_var("number_items", $number_items);
	if (!isset($is_valid))
     $is_valid = true;
if (!isset($item_included) && $is_valid)
{
		for($i = 1; $i <= $number_items; $i++)
		{
			$t->set_var("item_name", $eg->values[$i]["item_name"]);
			$t->set_var("item_name_hid", $eg->values[$i]["item_name"]);
			$t->set_var($eg->block_name . "_number", $i);
			$eg->set_record($i);
			$eg->record->set_parameters();
			$t->parse($eg->block_name, true);
		}
}
else if (!$is_valid)
{
		for($i = 1; $i <= $number_items; $i++)
		{
			$t->set_var($eg->block_name . "_number", $i);
			$eg->set_record($i);
			$eg->record->set_parameters();
      if (!isset($item_included))
      {
         $t->set_var("item_name", $eg->values[$i]["item_name_hid"]);
         $t->set_var("item_name", $eg->values[$i]["item_name_hid"]);
      }
      $errors_list = $eg->errors[$i];
			if ($errors_list) {
	      $t->set_var("errors_list", $errors_list);
  	    $t->parse("items_errors", false);
			} else {
  	    $t->set_var("items_errors", "");
			}
			$t->parse($eg->block_name, true);
		}
}
else
  $eg->set_parameters_all($number_items);

  $t->set_var("rp", htmlspecialchars($return_page));

  $t->parse("items_rows", false);
	$t->pparse("main");

?>
