<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                            ***
  ***      File:  admin_user_product.php                                   ***
  ***      Built: Tue Nov 14 19:00:40 2006                                 ***
  ***                                                  ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "messages/".$language_code."/cart_messages.php");
	include_once ($root_folder_path . "messages/".$language_code."/download_messages.php");

	check_admin_security("users_groups");

	$type_id = get_param("type_id");
	$setting_type = "user_product_" . $type_id;
	$sql = " SELECT type_name FROM " . $table_prefix . "user_types WHERE type_id=" . $db->tosql($type_id, INTEGER);
	$db->query($sql);
	if ($db->next_record()) {
		$type_name = $db->f("type_name");
	} else {
		header ("Location: admin_user_types.php");
		exit;
	}

	$validation_types =
		array(
			array(1, "Active"), array(0, "Not Used")
		);

	$message_types =
		array(
			array(1, "HTML"), array(0, "Plain Text")
		);

	$html_editors =
		array(
			array(1, "WYSIWYG Editor"),
			array(0, "Textarea Editor")
		);

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_user_product.html");

	$t->set_var("admin_href",              "admin.php");
	$t->set_var("admin_users_href",        "admin_users.php");
	$t->set_var("admin_user_types_href",   "admin_user_types.php");
	$t->set_var("admin_user_type_href",    "admin_user_type.php");
	$t->set_var("admin_user_product_href", "admin_user_product.php");
	$t->set_var("admin_user_product_help_href", "admin_user_product_help.php");
	$t->set_var("admin_email_help_href",   "admin_email_help.php");
	$t->set_var("user_home_href",          "user_home.php");
	$t->set_var("type_id",   $type_id);
	$t->set_var("type_name", $type_name);

	$t->set_var("HIDE_ADD_BUTTON_MSG", str_replace("{ADD_TO_CART_MSG}", ADD_TO_CART_MSG, HIDE_ADD_BUTTON_MSG));

	$r = new VA_Record($table_prefix . "global_settings");

	// product fields
	$product_fields = array(
		// general information
		"is_showing", "item_order", "friendly_url", "manufacturer_id", "manufacturer_code",
		"weight", "issue_date", "is_compared", "tax_free", "language_code",
		// pricing
		"is_price_edit", "price", "trade_price", "is_sales", "buying_price", "properties_price", "is_sales",
		"sales_price", "trade_sales",	"discount_percent",
		// descriptions
		"features", "short_description", "full_description",
		// meta
		"meta_title", "meta_keywords", "meta_description",
		// images
		"small_image", "small_image_alt", "big_image", "big_image_alt", "super_image",
		// appearance
		"template_name", "hide_add_list", "hide_add_details", "preview_url", "preview_width", "preview_height",
		// stock
		"use_stock_level", "stock_level", "hide_out_of_stock", "disable_out_of_stock",
		// shipping
		"shipping_in_stock", "shipping_out_stock", "shipping_rule_id",

		// Downloadable / Software Options
		"downloadable", "download_period", "download_path", "generate_serial", "activations_number", "predefined_serials",

		// Special Offer
		"is_special_offer", "special_offer",

		// Notifications
		"mail_notify", "mail_to", "mail_from", "mail_cc", "mail_bcc", "mail_reply_to", "mail_return_path", "mail_subject",
		"mail_type", "mail_body", "sms_notify", "sms_recipient", "sms_originator", "sms_message",
		// Rating Notes
		"votes", "points", "notes",	"buy_link"
	);
	for ($i = 0; $i < sizeof($product_fields); $i++) {
		$field_name = $product_fields[$i];
		$r->add_checkbox("show_" . $field_name, INTEGER);
		$r->add_checkbox($field_name . "_required", INTEGER);
	}

	$r->add_radio("features_editor", INTEGER, $html_editors);
	$r->add_radio("short_description_editor", INTEGER, $html_editors);
	$r->add_radio("full_description_editor", INTEGER, $html_editors);
	$r->add_radio("special_offer_editor", INTEGER, $html_editors);
	$r->add_radio("notes_editor", INTEGER, $html_editors);

	// email notification settings
	$r->add_checkbox("admin_notification", INTEGER);
	$r->add_textbox("admin_email", TEXT);
	$r->add_textbox("admin_mail_from", TEXT);
	$r->add_textbox("cc_emails", TEXT);
	$r->add_textbox("admin_mail_bcc", TEXT);
	$r->add_textbox("admin_mail_reply_to", TEXT);
	$r->add_textbox("admin_mail_return_path", TEXT);
	$r->add_textbox("admin_subject", TEXT);
	$r->add_radio("admin_message_type", TEXT, $message_types);
	$r->add_textbox("admin_message", TEXT);

	$r->add_checkbox("user_notification", INTEGER);
	$r->add_textbox("user_mail_from", TEXT);
	$r->add_textbox("user_mail_cc", TEXT);
	$r->add_textbox("user_mail_bcc", TEXT);
	$r->add_textbox("user_mail_reply_to", TEXT);
	$r->add_textbox("user_mail_return_path", TEXT);
	$r->add_textbox("user_subject", TEXT);
	$r->add_radio("user_message_type", TEXT, $message_types);
	$r->add_textbox("user_message", TEXT);

	// sms notification settings
	$r->add_checkbox("admin_sms_notification", INTEGER);
	$r->add_textbox("admin_sms_recipient", TEXT, "Administrator SMS Recipient");
	$r->add_textbox("admin_sms_originator", TEXT, "Administator SMS Originator");
	$r->add_textbox("admin_sms_message", TEXT, "Administator SMS Message");

	$r->add_checkbox("user_sms_notification", INTEGER);
	$r->add_textbox("user_sms_recipient", TEXT, "User SMS Recipient");
	$r->add_textbox("user_sms_originator", TEXT, "User SMS Originator");
	$r->add_textbox("user_sms_message", TEXT, "User SMS Message");

	$r->get_form_values();

	$operation = get_param("operation");
	$return_page = get_param("rp");
	if(!strlen($return_page)) $return_page = "admin_user_types.php";
	$t->set_var("rp", htmlspecialchars($return_page));

	if(strlen($operation))
	{
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}
		if ($r->get_value("admin_sms_notification")) {
			$r->change_property("admin_sms_recipient", REQUIRED, true);
			$r->change_property("admin_sms_message", REQUIRED, true);
		}
		if ($r->get_value("user_sms_notification")) {
			$r->change_property("user_sms_message", REQUIRED, true);
		}

		$r->validate();

		if(!strlen($r->errors))
		{
			$sql = "DELETE FROM " . $table_prefix . "global_settings WHERE setting_type=" . $db->tosql($setting_type, TEXT);
			$db->query($sql);
			foreach($r->parameters as $key => $value)
			{
				$sql  = "INSERT INTO " . $table_prefix . "global_settings (setting_type, setting_name, setting_value) VALUES (";
				$sql .= $db->tosql($setting_type, TEXT) . ", '" . $key . "'," . $db->tosql($value[CONTROL_VALUE], TEXT) . ")";
				$db->query($sql);
			}

			header("Location: " . $return_page);
			exit;
		}
	}
	else // get user_product settings
	{
		foreach($r->parameters as $key => $value)
		{
			$sql  = "SELECT setting_value FROM " . $table_prefix . "global_settings ";
			$sql .= "WHERE setting_type=" . $db->tosql($setting_type, TEXT) . " AND setting_name='" . $key . "'";
			$r->set_value($key, get_db_value($sql));
		}
	}

	$r->set_parameters();
	$t->set_var("type_id", htmlspecialchars($type_id));

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->set_var("admin_href", "admin.php");
	$t->pparse("main");

?>