<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***                                                       ***
  ***      File:  header.php                                               ***
  ***      Built: Fri Feb 23 18:29:53 2007                                 ***
  ***                                                 ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./block_login.php");

	$site_url = $settings["site_url"];
	$secure_url = get_setting_value($settings, "secure_url", "");
	if ($is_ssl) {
		$absolute_url = $secure_url;
		
	}

	$css_file = "";
	if (isset($settings["style_name"]) && $settings["style_name"]) {
		$css_file = "styles/" . $settings["style_name"];
		if (isset($settings["scheme_name"]) && $settings["scheme_name"]) {
			$css_file .= "_" . $settings["scheme_name"];
		}
		$css_file .= ".css";
	}

	$t->set_file("header", "header.html");
	$t->set_var("CHARSET", CHARSET);
	$t->set_var("site_url", $site_url);
	$t->set_var("secure_url", $secure_url);
	$t->set_var("css_file", $css_file);
	$t->set_var("menu", "");
	$request_uri = getenv("REQUEST_URI");
	if ($request_uri) {
		$slash_position = strrpos ($request_uri, "/");
		$request_uri = ($slash_position === false) ? $request_uri : substr($request_uri, $slash_position + 1);
	} 
	if (!$request_uri) {
		if(!isset($script_name)) {
			$script_name = isset($PHP_SELF) ? basename($PHP_SELF) : basename(getenv("SCRIPT_NAME"));
		}
		$query_string = getenv("QUERY_STRING");
		$request_uri = ($query_string) ? $script_name . "?" . $query_string : $script_name;
	}

	$menu = array(); $top_items = array();

	if (!$settings["layout_id"]) $settings["layout_id"] = 1;
	$header_where = get_session("session_user_id") ? " show_logged=1 " : " show_non_logged=1 ";
	$sql  = " SELECT * FROM " . $table_prefix . "header_links ";
	$sql .= " WHERE " . $header_where . " AND layout_id=" . $settings["layout_id"];
	$sql .= " ORDER BY menu_order ";
	$db->query($sql);
	while($db->next_record()) {

		$menu_id = $db->f("menu_id");
		$parent_menu_id = $db->f("parent_menu_id");
		if ($menu_id == $parent_menu_id) {
			$parent_menu_id = 0;
		}

		$menu_values = array(
			"menu_id" => $menu_id, "menu_url" => $db->f("menu_url"), "menu_title" => $db->f("menu_title"),
			"menu_image" => $db->f("menu_image"), "menu_image_active" => $db->f("menu_image_active"), "menu_path" => $db->f("menu_path")
		);

		$menu[$parent_menu_id][] = $menu_values;
	}


	foreach ($menu as $parent_menu_id => $menus) {

		for ($m = 0; $m < sizeof($menus); $m++) {

			$menu_id = $menus[$m]["menu_id"];
			$menu_url = $menus[$m]["menu_url"];
			$menu_title = $menus[$m]["menu_title"];
			$menu_image = $menus[$m]["menu_image"];
			$menu_image_active = $menus[$m]["menu_image_active"];
			$menu_path = $menus[$m]["menu_path"];
			$menu_path_id = str_replace(",", "_", $menu_path) . $menu_id;
	  
			$t->set_var("menu_path_id", $menu_path_id);
	  
			$menu_basename     = basename($menu_url);
			$menu_style        = "menu";
	  
			if ($request_uri == $menu_basename) {
				$menu_style = "menuActive";
				if ($menu_image_active) {
					$menu_image = $menu_image_active;
				}
			}
			$menu_title = get_translation($menu_title);
			if (defined($menu_title)) {
				$menu_title = constant($menu_title);
			}
			if (!preg_match("/^http\:\/\//", $menu_url) && !preg_match("/^https\:\/\//", $menu_url)) {
				$menu_url = $site_url . $menu_url;
			}
	  
  		$t->set_var("menu_href",  htmlspecialchars($menu_url));
      $t->set_var("menu_style", $menu_style);
   	 	$t->set_var("menu_title", htmlspecialchars($menu_title));
			if(strlen($menu_title)) {
				$t->sparse("menu_text", false);
			} else {
				$t->set_var("menu_text", "");
			}
	  
			if($menu_image && file_exists($menu_image))
			{ 
				// check image translation
				$slash_pos = strrpos($menu_image, "/");
				if ($slash_pos === false) {
					$menu_image_translation = $language_code . "/" . $menu_image;
				} else {
					$menu_image_translation = substr($menu_image, 0, $slash_pos) . "/" . $language_code . substr($menu_image, $slash_pos);
				}
				if (file_exists($menu_image_translation)) {
					$menu_image = $menu_image_translation;
				}
	    
				$image_size = @GetImageSize($menu_image);
				$t->set_var("alt", htmlspecialchars($menu_title));
				$t->set_var("src", htmlspecialchars($menu_image));
				if(is_array($image_size))
				{
					$t->set_var("width", "width=\"" . $image_size[0] . "\"");
					$t->set_var("height", "height=\"" . $image_size[1] . "\"");
				}
				else
				{
					$t->set_var("width", "");
					$t->set_var("height", "");
				}
				$t->sparse("menu_image", false);
				$t->set_var("menu_text", "");
			}
			else
			{
				if($menu_image) {
					$t->set_var("width", "width=125");
					$t->set_var("height", "height=30");
					$t->set_var("alt", "Bad image path");
				} else {
					$t->set_var("width", "width=0");
					$t->set_var("height", "height=0");
					$t->set_var("alt", "");
				}
				$t->set_var("src", "");
				$t->set_var("menu_image", "");
			}
	  
	  
			if ($parent_menu_id) {
				$t->sparse("sub_menu", true);
			} else {
				$t->sparse("menu", true);
			}
	  
		}

		// parse sub menus block
		if ($parent_menu_id > 0) {
			$menu_block_id = preg_replace("/,$/", "", $menu_path);
			$menu_block_id = "sm_" . str_replace(",", "_", $menu_block_id);

			$t->set_var("menu_block_id", $menu_block_id);
			$t->sparse("sub_menu_block", true);
			$t->set_var("sub_menu", "");
		}

	}

	$t->set_var("index_href", "index.php");
	$t->set_var("products_href", "products.php");
	$t->set_var("basket_href", "basket.php");
	$t->set_var("user_profile_href", "user_profile.php");
	$t->set_var("admin_href", "admin.php");
	$t->set_var("help_href", "page.php?page=help");
	$t->set_var("about_href", "page.php?page=about");

	if($t->block_exists("page_login_form")) {
		login_form("", "page_");
	}
	if(!isset($header_title)) { $header_title = ""; } 
	$t->set_var("header_title", $header_title);

	$t->parse("header", false);

?>